<?php use_helper( 'UrlFunctions' ); ?>
<?php use_helper( 'UtilFunctions' ); ?>
<?php use_helper( 'IncludePartial' ); ?>

<script type="text/javascript">
showAlertBootStrap = function( elm_id_content, class_default, message_alert )
{
    var html_alert = '<div class="alert ' + class_default + ' alert-dismissible fade show" role="alert"> ' +
            '' + message_alert +
            '<button type="button" class="close" data-dismiss="alert" aria-label="Close">' +
                '<span aria-hidden="true">&times;</span>' +
            '</button>' +
        '</div>';
    $( "#" + elm_id_content ).append( html_alert );
}

saveForm = function()
{
    x = confirm( "Esta seguro de guardar el formulario?" );
    if( x )
    {
        blockContent( 'content_buttons' );
        var strFormSerialize = $( 'form' ).serialize();
        
        executeAjaxJson
        ( 
            "<?php echo buildUrl( 'cajachica/ejecutarCierreCaja', "" ) ?>", 
            strFormSerialize,
            function( o_json )
            {
                unBlockContent( 'content_buttons' );
                if( o_json.error )
                {
                    showAlertBootStrap( 'content_alert', 'alert-danger', o_json.mensaje_error );
                    //mostrarMensajeError( o_json.mensaje_error );
                    return false;
                }

                location.href = "<?=buildUrl( 'cajachica/list', "" )?>";
            } 
        );
    }
    return false;
}

abrirReporteResumenCaja = function()
{
    if( $( '#IdCaja' ).val() != "" )
    {
        window.open( '<?=buildUrl( 'cajachica/cajaChicaResumenPDF', 'id_caja=' ) ?>' + $( '#IdCaja' ).val(), '_BLANK' );
    }
    else
    {
        showAlertBootStrap( 'content_alert', 'alert-danger', "Debe de seleccionar una Caja." );
    }
}
</script>

<div class="shadow-sm p-3 mb-2 bg-white rounded card card-body">
    <div class="row">
        <div class="col mb-1">
            <h4 class="text-info text-nowrap mb-0"><?=$s_Titulo?></h4>
        </div>
    </div>
</div>

<div id="content_alert" style=""></div>

<div class="card">
    <div class="container">
        <form class="was-validated" name="form1" id="form1" method="POST" action="" onsubmit="return saveForm();">
            <input type="hidden" name="IdCaja" id="IdCaja" value="<?=$s_IdCaja?>">
            
            <div class="form-group">
                <label class="col-form-label" for="FechaCierreCaja">Fecha Cierre</label>
                <input type="text" class="form-control form-control-sm text-center" id="FechaCierreCaja" name="FechaCierreCaja" value="<?=date("Y-m-d")?>" readonly="" >
            </div>
            <div class="form-group">
                <label class="col-form-label" for="MontoFondo">Fondo Actual</label>
                <input type="text" class="form-control form-control-sm text-center" value="<?=$o_TMP_ALM_CajaChicaCabBN->getMontoFondo()?>" readonly="">
            </div>
            <div class="form-group">
                <label for="MontoTotalDetalles" class="col-form-label">Monto Total Detalles:</label>
                <input type="text" class="form-control form-control-sm text-center" id="MontoTotalDetalles" name="MontoTotalDetalles" value="<?=$f_MontoTotalDetalles?>" readonly="">
            </div>
            <div class="form-group">
                <label for="MontoSaldoAct" class="col-form-label">Monto Saldo Actual:</label>
                <input type="text" class="form-control form-control-sm text-center" id="MontoSaldoAct" name="MontoSaldoAct" value="<?=$f_MontoSaldoActual?>" readonly>
            </div>

            <div class="form-row mx-0">
                <div class="col-md-4 mb-1">
                    <label class="col-form-label" for="Estado">Estado</label>
                    <select class="form-control form-control-sm custom-select my-0 mr-sm-2" id="Estado" name="Estado" required>
                        <option value="C"> CERRAR CAJA </option>
                    </select>
                </div>
            </div>

            <div class="dropdown-divider" style="border-top: 1px solid #8c8b8b;"></div>

            <div id="content_buttons">
                <div class="form-row mx-0" id="">
                    <div class="col-md-6 mb-1">
                        <button type="button" class="btn btn-primary btn-lg btn-block" onclick="location.href='<?php echo buildUrl( 'cajachica/list', '' ) ?>'">CANCELAR</button>
                    </div>
                    <?php if( !$Error ){ ?>
                    <div class="col-md-6 mb-1">
                        <button type="submit" class="btn btn-primary btn-lg btn-block" onclick="">GRABAR Y SALIR</button>
                    </div>
                    <?php } ?>
                </div>

                <div class="form-row mx-0" id="">
                    <div class="col-md mb-1">
                        <button type="button" class="btn btn-primary btn-lg btn-block" onclick="abrirReporteResumenCaja();">RESUMEN - PDF</button>
                    </div>
                </div>
            </div>

        </form>

    </div>

</div>

<script type="text/javascript">
<?php if( $Error ){ ?>
showAlertBootStrap( 'content_alert', 'alert-danger', "<?=$MensajeError?>" );
<?php } ?>
</script>