<?php
class SaveAsociarNCProvAction extends wtActions 
{
    public function execute()
    {
        $block      = $this->getRequestParameter( 'block' );
        $s_IdDet    = $this->getRequestParameter( 'IdDet' );
        $s_TipoProc = $this->getRequestParameter( 'TipoProc' );
        $TypeSub    = $this->getRequestParameter( 'TypeSub' );
        
        $SerieFactura  = str_pad( $this->getRequestParameter( 'SerieFactura' ), 4, "0", STR_PAD_LEFT );
        $NumeroFactura = str_pad( $this->getRequestParameter( 'NumeroFactura' ), 8, "0", STR_PAD_LEFT );
        $FechaFactura  = $this->getRequestParameter( 'FechaFactura' );
        $MontoFactura  = floatval( $this->getRequestParameter( 'MontoFactura' ) );
        $IGVFactura    = floatval( $this->getRequestParameter( 'IGVFactura' ) );
        $TotalFactura  = floatval( $this->getRequestParameter( 'TotalFactura' ) );
        $Comentario    = $this->getRequestParameter( 'Comentario' );
        
        $TipoDoc       = $this->getRequestParameter( 'TipoDoc' );

        try
        {
            //VALIDACION DE FECHA
            $b_FechaValid = UtilDate::validar_fecha( $FechaFactura );
            if( !$b_FechaValid )
            {
                throw new Exception( "Por favor ingrese una fecha Valida." );
            }
            if( !myUser::getUser()->getIdBusiness() )
            {
                throw new Exception( "La Session Expiro." );
            }
            /////////////////////
        
            $IdCompania    = ( int ) myUser::getUser()->getIdBusiness();
            $IdSucursal    = ( int ) myUser::getUser()->getIdSucursal();
            $IdAlmacen     = $this->getRequestParameter( 'IdAlmacen' );
            $IdOrdenCompra = ( int ) $this->getRequestParameter( 'IdOrdenCompra' );
            $IdPersona     = ( int ) $this->getRequestParameter( 'IdPersona' );
            $SerieGuia     = $SerieFactura;
            $NumeroGuia    = $NumeroFactura;
            
            $o_ALM_OrdenGuiaFacturaBN = new ALM_OrdenGuiaFacturaBN();
            $o_ALM_OrdenGuiaFacturaBN->setIdCompania( $IdCompania );
            //$o_ALM_OrdenGuiaFacturaBN->setIdSucursal( $IdSucursal );
            $o_ALM_OrdenGuiaFacturaBN->setIdAlmacen( $IdAlmacen );
            $o_ALM_OrdenGuiaFacturaBN->setIdOrdenCompra( $IdOrdenCompra );
            $o_ALM_OrdenGuiaFacturaBN->setIdPersona( $IdPersona );
            $o_ALM_OrdenGuiaFacturaBN->setSerieGuia( $SerieGuia );
            $o_ALM_OrdenGuiaFacturaBN->setNumeroGuia( $NumeroGuia );
            
            $o_ALM_OrdenGuiaFacturaBN->setTipoDoc( $TipoDoc );
            $o_ALM_OrdenGuiaFacturaBN->setSerieFactura( $SerieFactura );
            $o_ALM_OrdenGuiaFacturaBN->setNumeroFactura( $NumeroFactura );
            
            $o_ALM_OrdenGuiaFacturaBN->setFechaFactura( $FechaFactura );
            $o_ALM_OrdenGuiaFacturaBN->setMontoFactura( $MontoFactura );
            $o_ALM_OrdenGuiaFacturaBN->setIGVFactura( $IGVFactura );
            $o_ALM_OrdenGuiaFacturaBN->setTotalFactura( $TotalFactura );
            $o_ALM_OrdenGuiaFacturaBN->setComentario( $Comentario );
            	
            $a_Cantidad     = $this->getRequestParameter( 'Cantidad' ); //
            $a_IdItem       = $this->getRequestParameter( 'IdItem' ); //
            $a_Secuencia    = $this->getRequestParameter( 'IdSecuencia' ); //
        	
            $o_COM_OrdenCompraCabeceraBN = new COM_OrdenCompraCabeceraBN();
            $o_COM_OrdenCompraCabeceraBN->setIdCompania( $IdCompania );
            $o_COM_OrdenCompraCabeceraBN->setIdOrdenCompra( $IdOrdenCompra );
            $o_COM_OrdenCompraCabeceraBN->setIdAlmacenEntrega( $IdAlmacen );
            $o_COM_OrdenCompraCabeceraBN->setObjectOrdenGuiaFactura( $o_ALM_OrdenGuiaFacturaBN );
            
            foreach ( $a_IdItem as $i_Key => $s_Value )
            {
                $o_COM_OrdenCompraDetalleBN = new COM_OrdenCompraDetalleBN();
                $o_COM_OrdenCompraDetalleBN->setIdOrdenCompra( $IdOrdenCompra );
                $o_COM_OrdenCompraDetalleBN->setIdCompania( $IdCompania );
                $o_COM_OrdenCompraDetalleBN->setIdSecuencia( ( int ) $a_Secuencia[$i_Key] );
                $o_COM_OrdenCompraDetalleBN->setIdItem( $s_Value );
                $o_COM_OrdenCompraDetalleBN->setIdUnidad( 58 );
                $o_COM_OrdenCompraDetalleBN->setCantidadRecibida( floatval( $a_Cantidad[$i_Key] ) );
                $a_ArrayOrdenCompraDetalle[] = $o_COM_OrdenCompraDetalleBN;
            }
            
            $o_COM_OrdenCompraCabeceraBN->setArrayOrdenCompraDetalle( $a_ArrayOrdenCompraDetalle );
            
            $o_OrdenCompraBL = new OrdenCompraBL();
            $o_COM_OrdenCompraCabeceraBN = $o_OrdenCompraBL->iniciarAsociacionNotaCredito( $o_COM_OrdenCompraCabeceraBN );
            
            $o_ALM_TransaccionCabeceraBN = $o_COM_OrdenCompraCabeceraBN->getObjectTransaccion();
            $i_Id = $o_ALM_TransaccionCabeceraBN->getIdTransaccionCabeceraConcat();
            
            $a_Rs['id_trans']    = $i_Id;
            $a_Rs['fact_serie']  = $SerieFactura;
            $a_Rs['fact_numero'] = $NumeroFactura;
            $a_Rs['type_sub'] = $TypeSub;
            $a_Rs['error']    = false;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']        = true;
            $a_Rs['mensaje_error'] = $o_Exception->getMessage();
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
}