<?php
class RepDetalleCobranzaAction extends wtActions
{
    public function execute()
    {
        $s_TipoSalida       = trim( $this->getRequestParameter( 'TipoSalida' ) );
        $this->s_FechaDesde = trim( $this->getRequestParameter( 'FechaDocumento1' ) );
        $this->s_FechaHasta = trim( $this->getRequestParameter( 'FechaDocumento2' ) );

        if( $s_TipoSalida == "EXCEL" )
        {
            header( 'Content-Type: application/vnd.ms-excel' );
            header( 'Content-Disposition: attachment;filename="Detalle_Cobranza_Clientes_'.date( "Ymd" ).'.xls"' );
            header( 'Cache-Control: max-age=0' );
        }

        $o_GSS_CompaniaFN = new GSS_CompaniaFN();
        $this->o_GSS_CompaniaBN = $o_GSS_CompaniaFN->selectByPK( myUser::getUser()->getIdCompania() );

        $o_FCO_AplicacionFN = new FCO_AplicacionFN();
        $o_FCO_AplicacionFN->setEstado( FCO_AplicacionBN::ESTADO_APLICADO );
        if( $this->getRequestParameter( "FechaDocumento1" ) )
        {
            $o_FCO_AplicacionFN->addCondition( FCO_AplicacionFN::FechaAplicacion, ">=", $this->getRequestParameter( "FechaDocumento1" )." 00:00:00" );
        }
        if( $this->getRequestParameter( "FechaDocumento2" ) )
        {
            $o_FCO_AplicacionFN->addCondition( FCO_AplicacionFN::FechaAplicacion, "<=", $this->getRequestParameter( "FechaDocumento2" )." 23:59:59" );
        }
        if( $this->getRequestParameter( "TipoDocCliente" ) )
        {
            $o_FCO_AplicacionFN->setTipoDocCliente( $this->getRequestParameter( "TipoDocCliente" ) );
        }
        if( $this->getRequestParameter( "NumTipoDocCliente" ) )
        {
            $o_FCO_AplicacionFN->setNumTipoDocCliente( $this->getRequestParameter( "NumTipoDocCliente" ) );
        }
        if( $this->getRequestParameter( "ClienteNumero" ) )
        {
            $o_FCO_AplicacionFN->setIdPersona( $this->getRequestParameter( "ClienteNumero" ) );
        }
        if( $this->getRequestParameter( "NombreCliente" ) )
        {
            $o_FCO_AplicacionFN->addCondition( FCO_AplicacionFN::NombreCliente, "LIKE", "'%".$this->getRequestParameter( "NombreCliente" )."%'", false );
        }
        if( $this->getRequestParameter( "ReciboNumero" ) )
        {
            $o_FCO_AplicacionFN->addCondition( FCO_AplicacionFN::ReciboNumero, "LIKE", "'%".$this->getRequestParameter( "ReciboNumero" )."%'", false );
        }
        if( $this->getRequestParameter( "IdMoneda" ) )
        {
            $o_FCO_AplicacionFN->setIdMoneda( $this->getRequestParameter( "IdMoneda" ) );
        }
        /*if( $this->getRequestParameter( "CobranzaEstado" ) )
        {
            $o_FCO_AplicacionFN->setCobranzaEstado( $this->getRequestParameter( "CobranzaEstado" ) );
        }*/

        $o_FCO_AplicacionFN->addOrderBy( FCO_AplicacionFN::SerieNumeroDocRef );
        $this->a_FCO_Aplicacion = $o_FCO_AplicacionFN->select();

        if( $this->s_FechaDesde == "" )
        {
            $this->s_FechaDesde = "- - - - ";
        }
        if( $this->s_FechaHasta == "" )
        {
            $this->s_FechaHasta = date( "Y-m-d" );
        }

        ViewResponse::getInstance()->setMethodAjax();
    }
}
