<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: CAR_Vehiculo.xml */
/* Generado: 2024-12-31 05:16:49 */

/* Mantenimiento de los registros de la tabla CAR_Vehiculo */
abstract class BaseCAR_VehiculoDP extends CAR_VehiculoBV
{
    /* Constructor ( Establece los valores desde un objeto CAR_VehiculoBN ) */
    public function __construct( CAR_VehiculoBN $o_CAR_VehiculoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_CAR_VehiculoBN ) )
        {
            $this->setByBN( $o_CAR_VehiculoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto CAR_VehiculoBN */
    public function setByBN( CAR_VehiculoBN $o_CAR_VehiculoBN )
    {
        if ( !is_null( $o_CAR_VehiculoBN->getPlaca() ) )
        {
            $this->setPlaca( $o_CAR_VehiculoBN->getPlaca() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getPais() ) )
        {
            $this->setPais( $o_CAR_VehiculoBN->getPais() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getIdVehiculoTipo() ) )
        {
            $this->setIdVehiculoTipo( $o_CAR_VehiculoBN->getIdVehiculoTipo() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getIdVehiculoMarca() ) )
        {
            $this->setIdVehiculoMarca( $o_CAR_VehiculoBN->getIdVehiculoMarca() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getIdVehiculoModelo() ) )
        {
            $this->setIdVehiculoModelo( $o_CAR_VehiculoBN->getIdVehiculoModelo() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getNombreTipoVehiculo() ) )
        {
            $this->setNombreTipoVehiculo( $o_CAR_VehiculoBN->getNombreTipoVehiculo() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getNombreMarca() ) )
        {
            $this->setNombreMarca( $o_CAR_VehiculoBN->getNombreMarca() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getNombreModelo() ) )
        {
            $this->setNombreModelo( $o_CAR_VehiculoBN->getNombreModelo() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getColor() ) )
        {
            $this->setColor( $o_CAR_VehiculoBN->getColor() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getNumeroMotor() ) )
        {
            $this->setNumeroMotor( $o_CAR_VehiculoBN->getNumeroMotor() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getVin() ) )
        {
            $this->setVin( $o_CAR_VehiculoBN->getVin() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getJsonCad() ) )
        {
            $this->setJsonCad( $o_CAR_VehiculoBN->getJsonCad() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_CAR_VehiculoBN->getFechaCreacion() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_CAR_VehiculoBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_CAR_VehiculoBN->getFechaModificacion() );
        }
        if ( !is_null( $o_CAR_VehiculoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_CAR_VehiculoBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_CAR_VehiculoFN = new CAR_VehiculoFN();
        $o_CAR_VehiculoBN = $o_CAR_VehiculoFN->selectByPk( $this->getPlaca() );
        if ( is_null( $o_CAR_VehiculoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO CAR_Vehiculo ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getPlaca() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Placa";
                $s_SQLQuery2 .= $s_Separator."'".$this->getPlaca()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPais() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Pais";
                $s_SQLQuery2 .= $s_Separator."'".$this->getPais()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdVehiculoTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdVehiculoTipo";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdVehiculoTipo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdVehiculoMarca() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdVehiculoMarca";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdVehiculoMarca()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdVehiculoModelo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdVehiculoModelo";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdVehiculoModelo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreTipoVehiculo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreTipoVehiculo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreTipoVehiculo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreMarca() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreMarca";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreMarca()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreModelo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreModelo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreModelo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getColor() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Color";
                $s_SQLQuery2 .= $s_Separator."'".$this->getColor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroMotor() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroMotor";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroMotor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getVin() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Vin";
                $s_SQLQuery2 .= $s_Separator."'".$this->getVin()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getJsonCad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."JsonCad";
                $s_SQLQuery2 .= $s_Separator."'".$this->getJsonCad()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE CAR_Vehiculo SET ";
            $s_Separator = "";
            if ( !is_null( $this->getPais() ) )
            {
                $s_SQLQuery .= $s_Separator."Pais = '".$this->getPais()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdVehiculoTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."IdVehiculoTipo = ".$this->getIdVehiculoTipo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdVehiculoMarca() ) )
            {
                $s_SQLQuery .= $s_Separator."IdVehiculoMarca = ".$this->getIdVehiculoMarca()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdVehiculoModelo() ) )
            {
                $s_SQLQuery .= $s_Separator."IdVehiculoModelo = ".$this->getIdVehiculoModelo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreTipoVehiculo() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreTipoVehiculo = '".$this->getNombreTipoVehiculo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreMarca() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreMarca = '".$this->getNombreMarca()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreModelo() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreModelo = '".$this->getNombreModelo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getColor() ) )
            {
                $s_SQLQuery .= $s_Separator."Color = '".$this->getColor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroMotor() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroMotor = '".$this->getNumeroMotor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getVin() ) )
            {
                $s_SQLQuery .= $s_Separator."Vin = '".$this->getVin()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getJsonCad() ) )
            {
                $s_SQLQuery .= $s_Separator."JsonCad = '".$this->getJsonCad()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  Placa = '".$this->getPlaca()."';";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM CAR_Vehiculo WHERE  Placa = '".$this->getPlaca()."';";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>