<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: FCO_TipoPago.xml */
/* Generado: 2020-08-18 04:21:26 */

/* Mantenimiento de los registros de la tabla FCO_TipoPago */
abstract class BaseFCO_TipoPagoDP extends FCO_TipoPagoBV
{
    /* Constructor ( Establece los valores desde un objeto FCO_TipoPagoBN ) */
    public function __construct( FCO_TipoPagoBN $o_FCO_TipoPagoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_FCO_TipoPagoBN ) )
        {
            $this->setByBN( $o_FCO_TipoPagoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto FCO_TipoPagoBN */
    public function setByBN( FCO_TipoPagoBN $o_FCO_TipoPagoBN )
    {
        if ( !is_null( $o_FCO_TipoPagoBN->getIdTipoPago() ) )
        {
            $this->setIdTipoPago( $o_FCO_TipoPagoBN->getIdTipoPago() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_FCO_TipoPagoBN->getIdCompania() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getCodigo() ) )
        {
            $this->setCodigo( $o_FCO_TipoPagoBN->getCodigo() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getNombre() ) )
        {
            $this->setNombre( $o_FCO_TipoPagoBN->getNombre() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getClaseNombre() ) )
        {
            $this->setClaseNombre( $o_FCO_TipoPagoBN->getClaseNombre() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getMostrar() ) )
        {
            $this->setMostrar( $o_FCO_TipoPagoBN->getMostrar() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getEstado() ) )
        {
            $this->setEstado( $o_FCO_TipoPagoBN->getEstado() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_FCO_TipoPagoBN->getFechaCreacion() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_FCO_TipoPagoBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_FCO_TipoPagoBN->getFechaModificacion() );
        }
        if ( !is_null( $o_FCO_TipoPagoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_FCO_TipoPagoBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_FCO_TipoPagoFN = new FCO_TipoPagoFN();
        $o_FCO_TipoPagoBN = $o_FCO_TipoPagoFN->selectByPk( $this->getIdTipoPago() );
        if ( is_null( $o_FCO_TipoPagoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO FCO_TipoPago ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdTipoPago() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoPago";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdTipoPago()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Codigo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Nombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClaseNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ClaseNombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getClaseNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMostrar() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Mostrar";
                $s_SQLQuery2 .= $s_Separator."'".$this->getMostrar()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE FCO_TipoPago SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery .= $s_Separator."Codigo = '".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."Nombre = '".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClaseNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."ClaseNombre = '".$this->getClaseNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMostrar() ) )
            {
                $s_SQLQuery .= $s_Separator."Mostrar = '".$this->getMostrar()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdTipoPago = ".$this->getIdTipoPago().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM FCO_TipoPago WHERE  IdTipoPago = ".$this->getIdTipoPago().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>