<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: PLA_MarcacionEmpleado.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Mantenimiento de los registros de la tabla PLA_MarcacionEmpleado */
abstract class BasePLA_MarcacionEmpleadoDP extends PLA_MarcacionEmpleadoBV
{
    /* Constructor ( Establece los valores desde un objeto PLA_MarcacionEmpleadoBN ) */
    public function __construct( PLA_MarcacionEmpleadoBN $o_PLA_MarcacionEmpleadoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN ) )
        {
            $this->setByBN( $o_PLA_MarcacionEmpleadoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto PLA_MarcacionEmpleadoBN */
    public function setByBN( PLA_MarcacionEmpleadoBN $o_PLA_MarcacionEmpleadoBN )
    {
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getIdDiaSem() ) )
        {
            $this->setIdDiaSem( $o_PLA_MarcacionEmpleadoBN->getIdDiaSem() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getIdTipo() ) )
        {
            $this->setIdTipo( $o_PLA_MarcacionEmpleadoBN->getIdTipo() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getIdRegistro() ) )
        {
            $this->setIdRegistro( $o_PLA_MarcacionEmpleadoBN->getIdRegistro() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_PLA_MarcacionEmpleadoBN->getIdPersona() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getHoraMinutoDesde() ) )
        {
            $this->setHoraMinutoDesde( $o_PLA_MarcacionEmpleadoBN->getHoraMinutoDesde() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getHoraMinutoHasta() ) )
        {
            $this->setHoraMinutoHasta( $o_PLA_MarcacionEmpleadoBN->getHoraMinutoHasta() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getDiaSiguienteFlag() ) )
        {
            $this->setDiaSiguienteFlag( $o_PLA_MarcacionEmpleadoBN->getDiaSiguienteFlag() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getEstado() ) )
        {
            $this->setEstado( $o_PLA_MarcacionEmpleadoBN->getEstado() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getEliminado() ) )
        {
            $this->setEliminado( $o_PLA_MarcacionEmpleadoBN->getEliminado() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_PLA_MarcacionEmpleadoBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_PLA_MarcacionEmpleadoBN->getFechaCreacion() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_PLA_MarcacionEmpleadoBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_PLA_MarcacionEmpleadoBN->getFechaModificacion() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getUsuarioEliminado() ) )
        {
            $this->setUsuarioEliminado( $o_PLA_MarcacionEmpleadoBN->getUsuarioEliminado() );
        }
        if ( !is_null( $o_PLA_MarcacionEmpleadoBN->getFechaEliminado() ) )
        {
            $this->setFechaEliminado( $o_PLA_MarcacionEmpleadoBN->getFechaEliminado() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_PLA_MarcacionEmpleadoFN = new PLA_MarcacionEmpleadoFN();
        $o_PLA_MarcacionEmpleadoBN = $o_PLA_MarcacionEmpleadoFN->selectByPk( $this->getIdDiaSem(), $this->getIdTipo(), $this->getIdRegistro(), $this->getIdPersona() );
        if ( is_null( $o_PLA_MarcacionEmpleadoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO PLA_MarcacionEmpleado ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdDiaSem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdDiaSem";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdDiaSem()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraMinutoDesde() ) )
            {
                $s_SQLQuery1 .= $s_Separator."HoraMinutoDesde";
                $s_SQLQuery2 .= $s_Separator."'".$this->getHoraMinutoDesde()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraMinutoHasta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."HoraMinutoHasta";
                $s_SQLQuery2 .= $s_Separator."'".$this->getHoraMinutoHasta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDiaSiguienteFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DiaSiguienteFlag";
                $s_SQLQuery2 .= $s_Separator."".$this->getDiaSiguienteFlag()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Eliminado";
                $s_SQLQuery2 .= $s_Separator."".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE PLA_MarcacionEmpleado SET ";
            $s_Separator = "";
            if ( !is_null( $this->getHoraMinutoDesde() ) )
            {
                $s_SQLQuery .= $s_Separator."HoraMinutoDesde = '".$this->getHoraMinutoDesde()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraMinutoHasta() ) )
            {
                $s_SQLQuery .= $s_Separator."HoraMinutoHasta = '".$this->getHoraMinutoHasta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDiaSiguienteFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."DiaSiguienteFlag = ".$this->getDiaSiguienteFlag()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) )
            {
                $s_SQLQuery .= $s_Separator."Eliminado = ".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioEliminado = '".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaEliminado = '".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdDiaSem = ".$this->getIdDiaSem()." AND  IdTipo = '".$this->getIdTipo()."' AND  IdRegistro = '".$this->getIdRegistro()."' AND  IdPersona = ".$this->getIdPersona().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM PLA_MarcacionEmpleado WHERE  IdDiaSem = ".$this->getIdDiaSem()." AND  IdTipo = '".$this->getIdTipo()."' AND  IdRegistro = '".$this->getIdRegistro()."' AND  IdPersona = ".$this->getIdPersona().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>