<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: PR_ListaItem.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Mantenimiento de los registros de la tabla PR_ListaItem */
abstract class BasePR_ListaItemDP extends PR_ListaItemBV
{
    /* Constructor ( Establece los valores desde un objeto PR_ListaItemBN ) */
    public function __construct( PR_ListaItemBN $o_PR_ListaItemBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_PR_ListaItemBN ) )
        {
            $this->setByBN( $o_PR_ListaItemBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto PR_ListaItemBN */
    public function setByBN( PR_ListaItemBN $o_PR_ListaItemBN )
    {
        if ( !is_null( $o_PR_ListaItemBN->getIdPrListaItem() ) )
        {
            $this->setIdPrListaItem( $o_PR_ListaItemBN->getIdPrListaItem() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getIdPrGrupo() ) )
        {
            $this->setIdPrGrupo( $o_PR_ListaItemBN->getIdPrGrupo() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getTipoPrecio() ) )
        {
            $this->setTipoPrecio( $o_PR_ListaItemBN->getTipoPrecio() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getIdItem() ) )
        {
            $this->setIdItem( $o_PR_ListaItemBN->getIdItem() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getPrecioVenta() ) )
        {
            $this->setPrecioVenta( $o_PR_ListaItemBN->getPrecioVenta() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getPrecioDscto() ) )
        {
            $this->setPrecioDscto( $o_PR_ListaItemBN->getPrecioDscto() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getBufferDscto() ) )
        {
            $this->setBufferDscto( $o_PR_ListaItemBN->getBufferDscto() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_PR_ListaItemBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_PR_ListaItemBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_PR_ListaItemBN->getFechaCreacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_PR_ListaItemFN = new PR_ListaItemFN();
        $o_PR_ListaItemBN = $o_PR_ListaItemFN->selectByPk( $this->getIdPrListaItem() );
        if ( is_null( $o_PR_ListaItemBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO PR_ListaItem ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdPrListaItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPrListaItem";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPrListaItem()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPrGrupo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPrGrupo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdPrGrupo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoPrecio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoPrecio";
                $s_SQLQuery2 .= $s_Separator."".$this->getTipoPrecio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioVenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioVenta";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioVenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioDscto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioDscto";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioDscto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getBufferDscto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."BufferDscto";
                $s_SQLQuery2 .= $s_Separator."".$this->getBufferDscto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE PR_ListaItem SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdPrGrupo() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPrGrupo = '".$this->getIdPrGrupo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoPrecio() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoPrecio = ".$this->getTipoPrecio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioVenta() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioVenta = ".$this->getPrecioVenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioDscto() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioDscto = ".$this->getPrecioDscto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getBufferDscto() ) )
            {
                $s_SQLQuery .= $s_Separator."BufferDscto = ".$this->getBufferDscto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdPrListaItem = ".$this->getIdPrListaItem().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM PR_ListaItem WHERE  IdPrListaItem = ".$this->getIdPrListaItem().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>