<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_EstadoDevolucion.xml */
/* Generado: 2021-06-26 01:39:40 */

/* Mantenimiento de los registros de la tabla SR_EstadoDevolucion */
abstract class BaseSR_EstadoDevolucionDP extends SR_EstadoDevolucionBV
{
    /* Constructor ( Establece los valores desde un objeto SR_EstadoDevolucionBN ) */
    public function __construct( SR_EstadoDevolucionBN $o_SR_EstadoDevolucionBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_EstadoDevolucionBN ) )
        {
            $this->setByBN( $o_SR_EstadoDevolucionBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_EstadoDevolucionBN */
    public function setByBN( SR_EstadoDevolucionBN $o_SR_EstadoDevolucionBN )
    {
        if ( !is_null( $o_SR_EstadoDevolucionBN->getEstadoDevolucionId() ) )
        {
            $this->setEstadoDevolucionId( $o_SR_EstadoDevolucionBN->getEstadoDevolucionId() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_SR_EstadoDevolucionBN->getDescripcion() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getFlagCobroExtra() ) )
        {
            $this->setFlagCobroExtra( $o_SR_EstadoDevolucionBN->getFlagCobroExtra() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getFlagSalida() ) )
        {
            $this->setFlagSalida( $o_SR_EstadoDevolucionBN->getFlagSalida() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getFlagEntrada() ) )
        {
            $this->setFlagEntrada( $o_SR_EstadoDevolucionBN->getFlagEntrada() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getFlagVentaServicio() ) )
        {
            $this->setFlagVentaServicio( $o_SR_EstadoDevolucionBN->getFlagVentaServicio() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getFlagVentaProducto() ) )
        {
            $this->setFlagVentaProducto( $o_SR_EstadoDevolucionBN->getFlagVentaProducto() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getColor() ) )
        {
            $this->setColor( $o_SR_EstadoDevolucionBN->getColor() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_SR_EstadoDevolucionBN->getIdAlmacen() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getIdItemServicio() ) )
        {
            $this->setIdItemServicio( $o_SR_EstadoDevolucionBN->getIdItemServicio() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SR_EstadoDevolucionBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SR_EstadoDevolucionBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SR_EstadoDevolucionBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SR_EstadoDevolucionBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SR_EstadoDevolucionBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_EstadoDevolucionFN = new SR_EstadoDevolucionFN();
        $o_SR_EstadoDevolucionBN = $o_SR_EstadoDevolucionFN->selectByPk( $this->getEstadoDevolucionId() );
        if ( is_null( $o_SR_EstadoDevolucionBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_EstadoDevolucion ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getEstadoDevolucionId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoDevolucionId";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoDevolucionId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagCobroExtra() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagCobroExtra";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFlagCobroExtra()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagSalida() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagSalida";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFlagSalida()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagEntrada() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagEntrada";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFlagEntrada()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagVentaServicio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagVentaServicio";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFlagVentaServicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagVentaProducto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagVentaProducto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFlagVentaProducto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getColor() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Color";
                $s_SQLQuery2 .= $s_Separator."'".$this->getColor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItemServicio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItemServicio";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItemServicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_EstadoDevolucion SET ";
            $s_Separator = "";
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagCobroExtra() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagCobroExtra = '".$this->getFlagCobroExtra()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagSalida() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagSalida = '".$this->getFlagSalida()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagEntrada() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagEntrada = '".$this->getFlagEntrada()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagVentaServicio() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagVentaServicio = '".$this->getFlagVentaServicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagVentaProducto() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagVentaProducto = '".$this->getFlagVentaProducto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getColor() ) )
            {
                $s_SQLQuery .= $s_Separator."Color = '".$this->getColor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacen = '".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItemServicio() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItemServicio = '".$this->getIdItemServicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  EstadoDevolucionId = '".$this->getEstadoDevolucionId()."';";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_EstadoDevolucion WHERE  EstadoDevolucionId = '".$this->getEstadoDevolucionId()."';";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>