<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_EstadosHabitacionMast.xml */
/* Generado: 2022-04-18 21:14:58 */

/* Busqueda de registros de la tabla MST_EstadosHabitacionMast. */
abstract class BaseMST_EstadosHabitacionMastFN extends MST_EstadosHabitacionMastBN
{
    /* Declaracion de constantes */
    const IdEstados = "MST_EstadosHabitacionMast.IdEstados";
    const IdCompania = "MST_EstadosHabitacionMast.IdCompania";
    const IdSucursal = "MST_EstadosHabitacionMast.IdSucursal";
    const Nombre = "MST_EstadosHabitacionMast.Nombre";
    const CodigoColorImg = "MST_EstadosHabitacionMast.CodigoColorImg";
    const CodigoColorPrincipal = "MST_EstadosHabitacionMast.CodigoColorPrincipal";
    const Secuencia = "MST_EstadosHabitacionMast.Secuencia";
    const Estado = "MST_EstadosHabitacionMast.Estado";
    const FechaCreacion = "MST_EstadosHabitacionMast.FechaCreacion";
    const UsuarioCreacion = "MST_EstadosHabitacionMast.UsuarioCreacion";
    const FechaModificacion = "MST_EstadosHabitacionMast.FechaModificacion";
    const UsuarioModificacion = "MST_EstadosHabitacionMast.UsuarioModificacion";

    public $a_Condition = array();
    public $a_OrderBy = array();
    public $a_GroupBy = array();
    public $b_Debug = false;

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        $o_DBConnect = Conexion::getConexion();
        return $o_DBConnect;
    }

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "MST_EstadosHabitacionMast.IdEstados AS IdEstados, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.IdCompania AS IdCompania, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.IdSucursal AS IdSucursal, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.Nombre AS Nombre, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.CodigoColorImg AS CodigoColorImg, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.CodigoColorPrincipal AS CodigoColorPrincipal, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.Secuencia AS Secuencia, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.Estado AS Estado, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.FechaCreacion AS FechaCreacion, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.UsuarioCreacion AS UsuarioCreacion, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.FechaModificacion AS FechaModificacion, ";
        $s_SQLQuery .= "MST_EstadosHabitacionMast.UsuarioModificacion AS UsuarioModificacion ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value, $b_ComSimple = true )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value, "FLAG_COMILLAS" => $b_ComSimple );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece el orden de la lista resultante */
    public function addGroupBy( $s_Const )
    {
        $this->a_GroupBy[] = array( "COLUMN" => $s_Const );
    }

    /* Establece los valores desde un objeto MST_EstadosHabitacionMastBN */
    public function setByBN( MST_EstadosHabitacionMastBN $o_MST_EstadosHabitacionMastBN )
    {
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getIdEstados() ) )
        {
            $this->setIdEstados( $o_MST_EstadosHabitacionMastBN->getIdEstados() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_EstadosHabitacionMastBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MST_EstadosHabitacionMastBN->getIdSucursal() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getNombre() ) )
        {
            $this->setNombre( $o_MST_EstadosHabitacionMastBN->getNombre() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getCodigoColorImg() ) )
        {
            $this->setCodigoColorImg( $o_MST_EstadosHabitacionMastBN->getCodigoColorImg() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getCodigoColorPrincipal() ) )
        {
            $this->setCodigoColorPrincipal( $o_MST_EstadosHabitacionMastBN->getCodigoColorPrincipal() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getSecuencia() ) )
        {
            $this->setSecuencia( $o_MST_EstadosHabitacionMastBN->getSecuencia() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_EstadosHabitacionMastBN->getEstado() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_EstadosHabitacionMastBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_EstadosHabitacionMastBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_EstadosHabitacionMastBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_EstadosHabitacionMastBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_EstadosHabitacionMastBN->getUsuarioModificacion() );
        }
    }

    /**
    * @return MST_EstadosHabitacionMastBN|null
    * @throws SQLException
    */
    public function selectByPK( $i_IdEstados )
    {
        if( is_null( $i_IdEstados ) ){ $i_IdEstados = -1; } 
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM MST_EstadosHabitacionMast ";
        $s_SQLQuery .= "WHERE IdEstados = ".$i_IdEstados." ";
        $s_SQLQuery .= "LIMIT 1;";
        $o_MST_EstadosHabitacionMastBN = null;
        $f_Micro1 = microtime( true );
        $o_ResultSet = $this->getConnect()->prepareStatement( $s_SQLQuery )->executeQuery();
        $f_Micro2 = microtime( true );
        if( $this->getDebug() ){ pr( "[".( round( $f_Micro2 - $f_Micro1, 2 ) )."] ".$s_SQLQuery ); }
        $i_NumRows   = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            $o_ResultSet->next();
            $a_SQLRow = $o_ResultSet->getRow(); //devuele array
            $o_MST_EstadosHabitacionMastBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_MST_EstadosHabitacionMastBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getIdEstados() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.IdEstados = ".$this->getIdEstados()." AND ";
        if ( !is_null( $this->getIdCompania() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.IdCompania = ".$this->getIdCompania()." AND ";
        if ( !is_null( $this->getIdSucursal() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.IdSucursal = ".$this->getIdSucursal()." AND ";
        if ( !is_null( $this->getNombre() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.Nombre = '".$this->getNombre()."' AND ";
        if ( !is_null( $this->getCodigoColorImg() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.CodigoColorImg = '".$this->getCodigoColorImg()."' AND ";
        if ( !is_null( $this->getCodigoColorPrincipal() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.CodigoColorPrincipal = '".$this->getCodigoColorPrincipal()."' AND ";
        if ( !is_null( $this->getSecuencia() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.Secuencia = ".$this->getSecuencia()." AND ";
        if ( !is_null( $this->getEstado() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.Estado = '".$this->getEstado()."' AND ";
        if ( !is_null( $this->getFechaCreacion() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.FechaCreacion = '".$this->getFechaCreacion()."' AND ";
        if ( !is_null( $this->getUsuarioCreacion() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.UsuarioCreacion = '".$this->getUsuarioCreacion()."' AND ";
        if ( !is_null( $this->getFechaModificacion() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.FechaModificacion = '".$this->getFechaModificacion()."' AND ";
        if ( !is_null( $this->getUsuarioModificacion() ) ) $s_SQLQuery .= "MST_EstadosHabitacionMast.UsuarioModificacion = '".$this->getUsuarioModificacion()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                if( $a_Condition['FLAG_COMILLAS'] )
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM MST_EstadosHabitacionMast WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $o_ResultSet->next();
        $i_NumRows    = $o_ResultSet->getInt( 'cnt' );
        return $i_NumRows;
    }

    /**
    * @param null $i_Position
    * @param null $i_Rows
    * @return MST_EstadosHabitacionMastBN[]
    * @throws SQLException
    */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM MST_EstadosHabitacionMast WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";

        $a_MST_EstadosHabitacionMastBN = array();
        $f_Micro1 = microtime( true );
        $o_ResultSet = $this->getConnect()->prepareStatement( $s_SQLQuery )->executeQuery();
        $f_Micro2 = microtime( true );
        if( $this->getDebug() ){ pr( "[".( round( $f_Micro2 - $f_Micro1, 2 ) )."] ".$s_SQLQuery ); }
        $i_NumRows = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            while( $o_ResultSet->next() ) 
            {
                $a_SQLRow = $o_ResultSet->getRow(); //devuele array
                $o_MST_EstadosHabitacionMastBN = $this->insertObjectBN( $a_SQLRow );
                $a_MST_EstadosHabitacionMastBN[] = $o_MST_EstadosHabitacionMastBN;
            }
        }
        return $a_MST_EstadosHabitacionMastBN;
    }

    /* Devuelve un objeto MST_EstadosHabitacionMastBN desde un objeto propel */
    public function insertObjectBN( $a_MST_EstadosHabitacionMast )
    {
        $o_MST_EstadosHabitacionMastBN = new MST_EstadosHabitacionMastBN();
        if ( !is_null( $a_MST_EstadosHabitacionMast['IdEstados'] ) ) $o_MST_EstadosHabitacionMastBN->setIdEstados( ( integer ) $a_MST_EstadosHabitacionMast['IdEstados'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['IdCompania'] ) ) $o_MST_EstadosHabitacionMastBN->setIdCompania( ( integer ) $a_MST_EstadosHabitacionMast['IdCompania'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['IdSucursal'] ) ) $o_MST_EstadosHabitacionMastBN->setIdSucursal( ( integer ) $a_MST_EstadosHabitacionMast['IdSucursal'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['Nombre'] ) ) $o_MST_EstadosHabitacionMastBN->setNombre( $a_MST_EstadosHabitacionMast['Nombre'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['CodigoColorImg'] ) ) $o_MST_EstadosHabitacionMastBN->setCodigoColorImg( $a_MST_EstadosHabitacionMast['CodigoColorImg'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['CodigoColorPrincipal'] ) ) $o_MST_EstadosHabitacionMastBN->setCodigoColorPrincipal( $a_MST_EstadosHabitacionMast['CodigoColorPrincipal'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['Secuencia'] ) ) $o_MST_EstadosHabitacionMastBN->setSecuencia( ( integer ) $a_MST_EstadosHabitacionMast['Secuencia'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['Estado'] ) ) $o_MST_EstadosHabitacionMastBN->setEstado( $a_MST_EstadosHabitacionMast['Estado'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['FechaCreacion'] ) ) $o_MST_EstadosHabitacionMastBN->setFechaCreacion( utilTimestamp::getTimestamp( $a_MST_EstadosHabitacionMast['FechaCreacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_MST_EstadosHabitacionMast['UsuarioCreacion'] ) ) $o_MST_EstadosHabitacionMastBN->setUsuarioCreacion( $a_MST_EstadosHabitacionMast['UsuarioCreacion'] );
        if ( !is_null( $a_MST_EstadosHabitacionMast['FechaModificacion'] ) ) $o_MST_EstadosHabitacionMastBN->setFechaModificacion( utilTimestamp::getTimestamp( $a_MST_EstadosHabitacionMast['FechaModificacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_MST_EstadosHabitacionMast['UsuarioModificacion'] ) ) $o_MST_EstadosHabitacionMastBN->setUsuarioModificacion( $a_MST_EstadosHabitacionMast['UsuarioModificacion'] );
        return $o_MST_EstadosHabitacionMastBN;
    }
}
?>